aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorMattias Andrée <maandree@kth.se>2016-03-27 21:25:38 +0200
committerMattias Andrée <maandree@kth.se>2016-03-27 21:25:38 +0200
commitc3a9eba0ec03fd8d5d7add17af16300e87ab11bc (patch)
tree634958c4404ea412ffd3f546972675a01573c0d9
parentadd yes test (diff)
downloadbase-util-tests-c3a9eba0ec03fd8d5d7add17af16300e87ab11bc.tar.gz
base-util-tests-c3a9eba0ec03fd8d5d7add17af16300e87ab11bc.tar.bz2
base-util-tests-c3a9eba0ec03fd8d5d7add17af16300e87ab11bc.tar.xz
add tac test
Signed-off-by: Mattias Andrée <maandree@kth.se>
-rw-r--r--tac-test/1.in0
-rw-r--r--tac-test/1.out0
-rw-r--r--tac-test/12345.outbin0 -> 33 bytes
-rw-r--r--tac-test/2.in1
-rw-r--r--tac-test/2.out1
-rw-r--r--tac-test/3.in1
-rw-r--r--tac-test/3.out1
-rw-r--r--tac-test/4.in8
-rw-r--r--tac-test/4.out8
-rw-r--r--tac-test/5.inbin0 -> 16 bytes
-rw-r--r--tac-test/5.outbin0 -> 16 bytes
-rwxr-xr-xtac-test/test75
-rwxr-xr-xtest-all3
13 files changed, 97 insertions, 1 deletions
diff --git a/tac-test/1.in b/tac-test/1.in
new file mode 100644
index 0000000..e69de29
--- /dev/null
+++ b/tac-test/1.in
diff --git a/tac-test/1.out b/tac-test/1.out
new file mode 100644
index 0000000..e69de29
--- /dev/null
+++ b/tac-test/1.out
diff --git a/tac-test/12345.out b/tac-test/12345.out
new file mode 100644
index 0000000..3b6dea8
--- /dev/null
+++ b/tac-test/12345.out
Binary files differ
diff --git a/tac-test/2.in b/tac-test/2.in
new file mode 100644
index 0000000..8b13789
--- /dev/null
+++ b/tac-test/2.in
@@ -0,0 +1 @@
+
diff --git a/tac-test/2.out b/tac-test/2.out
new file mode 100644
index 0000000..8b13789
--- /dev/null
+++ b/tac-test/2.out
@@ -0,0 +1 @@
+
diff --git a/tac-test/3.in b/tac-test/3.in
new file mode 100644
index 0000000..7898192
--- /dev/null
+++ b/tac-test/3.in
@@ -0,0 +1 @@
+a
diff --git a/tac-test/3.out b/tac-test/3.out
new file mode 100644
index 0000000..7898192
--- /dev/null
+++ b/tac-test/3.out
@@ -0,0 +1 @@
+a
diff --git a/tac-test/4.in b/tac-test/4.in
new file mode 100644
index 0000000..863cbb8
--- /dev/null
+++ b/tac-test/4.in
@@ -0,0 +1,8 @@
+a
+b
+c
+
+
+d
+e
+f
diff --git a/tac-test/4.out b/tac-test/4.out
new file mode 100644
index 0000000..a9396d4
--- /dev/null
+++ b/tac-test/4.out
@@ -0,0 +1,8 @@
+f
+e
+d
+
+
+c
+b
+a
diff --git a/tac-test/5.in b/tac-test/5.in
new file mode 100644
index 0000000..84f989f
--- /dev/null
+++ b/tac-test/5.in
Binary files differ
diff --git a/tac-test/5.out b/tac-test/5.out
new file mode 100644
index 0000000..eb83d15
--- /dev/null
+++ b/tac-test/5.out
Binary files differ
diff --git a/tac-test/test b/tac-test/test
new file mode 100755
index 0000000..769e226
--- /dev/null
+++ b/tac-test/test
@@ -0,0 +1,75 @@
+#!/bin/bash
+
+cd -- "$(dirname "$0")"
+if test -z "$TAC"; then
+ TAC=../tac
+fi
+N=5
+t="$PREFIX $TAC"
+
+report ()
+{
+ if test $1 = 0; then
+ printf "\033[1;32mTest %s OK\033[m\n" "$2"
+ else
+ printf "\033[1;31mTest %s FAILED\033[m\n" "$2"
+ fi
+}
+
+test_file ()
+{
+ diff <($t < $1.in) $1.out > /dev/null
+ report $? "file_$1"
+}
+
+
+file_1 () { test_file 1; }
+file_2 () { test_file 2; }
+file_3 () { test_file 3; }
+file_4 () { test_file 4; }
+file_5 () { test_file 5; }
+
+dash ()
+{
+ diff <($t - < 4.in) 4.out > /dev/null
+ report $? "dash"
+}
+
+file_one ()
+{
+ diff <($t 4.in) 4.out > /dev/null
+ report $? "file_one"
+}
+
+file_many ()
+{
+ diff <($t 1.in 2.in 3.in 4.in 5.in) 12345.out > /dev/null
+ report $? "file_many"
+}
+
+file_dash ()
+{
+ diff <($t 1.in 2.in 3.in 4.in - < 5.in) 12345.out > /dev/null
+ report $? "file_dash"
+}
+
+
+if test $# = 0; then
+ set $(printf 'file_%i\n' $(seq 1 $N)) dash file_one file_many file_dash
+fi
+(
+for f in $@; do
+ $f
+done
+) | tee result
+! grep FAILED < result > /dev/null
+ret=$?
+if test $ret != 0; then
+ if test $(grep FAILED < result | grep -v NON-STANDARD | wc -l) = 0; then
+ ret=1
+ else
+ ret=2
+ fi
+fi
+rm result
+exit $ret
diff --git a/test-all b/test-all
index c07f765..e5d16e1 100755
--- a/test-all
+++ b/test-all
@@ -6,7 +6,8 @@ function all()
{
echo patch md5sum rawshake256sum rawshake512sum sha1sum sha224sum sha256sum sha3-224sum \
sha3-256sum sha3-384sum sha3-512sum sha384sum sha512-224sum sha512-256sum sha512sum \
- shake256sum shake512sum cksum true false echo test basename dirname uniq cat yes
+ shake256sum shake512sum cksum true false echo test basename dirname uniq cat yes \
+ tac
}
exec 99>&2